"""Send execution_error message instead of execution_failed

Revision ID: 491d1dbafa67
Revises: 02b235378270
Create Date: 2021-12-21 14:38:38.706117

"""
from alembic import op

# revision identifiers, used by Alembic.
revision = "491d1dbafa67"
down_revision = "02b235378270"
branch_labels = None
depends_on = None


def upgrade():
    """
    Capability transitions that go into the error state should send execution_error messages,
    not execution_failed messages
    """
    execution_error_msg_sql = """
    UPDATE capability_state_actions
    SET arguments = 'execution_error'
    FROM capability_state_transitions
    WHERE capability_state_actions.transition_id = capability_state_transitions.transition_id
        AND action_type = 'SendMessage'
        AND capability_state_transitions.to_state = 'Error';
    """
    op.execute(execution_error_msg_sql)


def downgrade():
    execution_failed_msg_sql = """
    UPDATE capability_state_actions
    SET arguments = 'execution_failed'
    FROM capability_state_transitions
    WHERE capability_state_actions.transition_id = capability_state_transitions.transition_id
        AND action_type = 'SendMessage'
        AND capability_state_transitions.to_state = 'Error';
    """
    op.execute(execution_failed_msg_sql)
