"""incorporate QA into std_calibration state machine

Revision ID: acfdeb6777cb
Revises: 8ad5f0630fc0
Create Date: 2021-11-09 10:06:10.915761

"""
from alembic import op

# revision identifiers, used by Alembic.
revision = "acfdeb6777cb"
down_revision = "8ad5f0630fc0"
branch_labels = None
depends_on = None


def upgrade():
    """
    Change transition [Executing] -(workflow-complete)-> [Complete] TO [Executing] -(workflow-complete)-> [Awaiting QA]
    AND
    Add action for that transition: SendMessage qa_ready
    """

    op.execute(
        """
        UPDATE capability_state_transitions SET to_state = 'Awaiting QA'
        WHERE from_state = 'Executing' AND pattern = 'type == workflow-complete'
        AND capability_name = 'std_calibration';

        INSERT INTO capability_state_actions (transition_id, action_type, arguments)
        SELECT transition_id, 'SendMessage', 'qa_ready' AS arguments
        FROM capability_state_transitions WHERE pattern = 'type == workflow-complete'
        AND capability_name = 'std_calibration';
        """
    )


def downgrade():

    op.execute(
        """
        UPDATE capability_state_transitions SET to_state = 'Complete'
        WHERE from_state = 'Executing' AND pattern = 'type == workflow-complete' AND capability_name = 'std_calibration';

        DELETE FROM capability_state_actions WHERE action_type = 'SendMessage'
        AND arguments = 'qa_ready'
        AND transition_id = (
            SELECT transition_id FROM capability_state_transitions
            WHERE pattern = 'type == workflow-complete' AND capability_name = 'std_calibration'
        );
        """
    )
