"""correct calibration state machine

Revision ID: baf4d187d454
Revises: 491d1dbafa67
Create Date: 2021-12-21 14:57:54.222820

"""
from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision = "baf4d187d454"
down_revision = "491d1dbafa67"
branch_labels = None
depends_on = None


def upgrade():
    op.execute(
        f"""
        INSERT INTO capability_state_transitions (capability_name, from_state, pattern, to_state) 
        VALUES ('std_calibration', 'Awaiting QA', 'type == qa-complete', 'Failed') 
        """
    )
    op.execute(
        f"""
        UPDATE capability_state_transitions 
        SET pattern='type == ingestion-complete' 
        WHERE from_state='Ingesting' AND to_state='Complete' AND capability_name='std_calibration'
        """
    )
    op.execute(
        f"""
        UPDATE capability_state_transitions 
        SET pattern='type == ingestion-failed' 
        WHERE from_state='Ingesting' AND to_state='Error' AND capability_name='std_calibration'
        """
    )


def downgrade():
    op.execute(
        f"""
        DELETE FROM capability_state_transitions 
        WHERE capability_name='std_calibration' AND pattern='type == qa-complete'
        """
    )
    op.execute(
        f"""
        UPDATE capability_state_transitions 
        SET pattern='type == workflow-complete' 
        WHERE from_state='Ingesting' AND to_state='Complete' AND capability_name='std_calibration'
        """
    )
    op.execute(
        f"""
        UPDATE capability_state_transitions 
        SET pattern='type == workflow-failed' 
        WHERE from_state='Ingesting' AND to_state='Error' AND capability_name='std_calibration'
        """
    )
